// 012 u_dump_interface
// 04 jun 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_dump_interface;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
        StdCtrls, DBCtrls;

    type TForm1= class(TForm)
                   Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    display_object_: TButton;
    ci_detail_: TButton;
    create_: TButton;
    methods_: TButton;
    vmt_: TButton;
    imt_: TButton;
    object_: TButton;
    dump_object_: TButton;
    dump_vmt_: TButton;
    dump_imt_: TButton;
    dump_thunk_: TButton;
    call_: TButton;
                   procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure display_object_Click(Sender: TObject);
    procedure ci_detail_Click(Sender: TObject);
    procedure create_Click(Sender: TObject);
    procedure methods_Click(Sender: TObject);
    procedure vmt_Click(Sender: TObject);
    procedure imt_Click(Sender: TObject);
    procedure object_Click(Sender: TObject);
    procedure dump_vmt_Click(Sender: TObject);
    procedure dump_object_Click(Sender: TObject);
    procedure dump_imt_Click(Sender: TObject);
    procedure dump_thunk_Click(Sender: TObject);
    procedure call_Click(Sender: TObject);
                   private
                   { Dclarations prives }
                   public
                   { Dclarations publiques }
                 end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display, u_display_hex_2
        , u_vmt_imt
        , u_ci_square
    ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- the object and interfaces

    var g_ci_square: ci_square= Nil;
        g_i_compute: i_compute;
        g_i_journal: i_journal;
        g_i_unknown: iUnknown;

    procedure TForm1.create_Click(Sender: TObject);
      begin
        g_ci_square:= ci_square.create;
        g_i_unknown:= g_ci_square as iUnknown;
        g_i_compute:= g_ci_square as i_compute;
        g_i_journal:= g_ci_square as i_journal;
      end; // create_Click

    procedure TForm1.dump_object_Click(Sender: TObject);
      begin
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('object ci_square '+ f_integer_to_hex(Integer(g_ci_square)));
        display(f_display_hex(g_ci_square, 4+ 4+ 4+ 8+ 2* 4, 4, k_hex_address_hex));
      end; // dump_object_Click

    procedure TForm1.dump_vmt_Click(Sender: TObject);

      procedure display_the_vmt(p_pt_object: Pointer);
        var l_pt_vmt: t_pt_vmt;
        begin
          l_pt_vmt:= t_pt_vmt(p_pt_object^);

          display('vmt '+ f_integer_to_hex(Integer(l_pt_vmt)));
          display(f_display_hex(Pointer(Integer(l_pt_vmt)- k_vmt_entries* 4),
                  k_vmt_entries* 4+ 4,
                  4, k_hex_address));
        end; // display_the_vmt

      begin // dump_vmt_Click
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display_the_vmt(g_ci_square);
      end; // dump_vmt_Click

    procedure TForm1.dump_imt_Click(Sender: TObject);
      begin
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('i1 '+ f_integer_to_hex(Integer(g_i_compute)));
        display_vmt(Pointer(g_i_compute), 3+ 2);
      end; // dump_imt_Click

    procedure TForm1.dump_thunk_Click(Sender: TObject);
      var l_delta: Integer;

      procedure dump_thunk(p_pt_interface: Pointer; p_method_index: Integer);
        const k_add_byte_ptr_esp= $04244483;
              k_jump= $E9;
        type t_vmt= array[0..0] of Integer;
             t_pt_vmt= ^t_vmt;
             t_method_thunk= packed record
                                      m_offset_self: longint;
                                      m_delta: byte;
                                      m_jump: Byte;
                                      m_jump_to_method_start: longint;
                                    end;
             t_pt_method_thunk= ^t_method_thunk;
        var l_pt_method_thunk: t_pt_method_thunk;
            l_method_address: Integer;
        begin
          (*$r-*)
          l_pt_method_thunk:= t_pt_method_thunk(t_pt_vmt(p_pt_interface^)[p_method_index]);
          (*$r+*)

          display(f_display_hex(l_pt_method_thunk, SizeOf(t_method_thunk), 4, k_hex_address));
          if (l_pt_method_thunk^.m_offset_self= k_add_byte_ptr_esp) and (l_pt_method_thunk^.m_jump= k_jump)
            then begin
                // -- compute the absolute adress, starting from the start of "JMP XXX"
                l_method_address:= $0A+ Longint(l_pt_method_thunk)+ l_pt_method_thunk^.m_jump_to_method_start;
                display('  jmp '+ f_integer_to_hex(l_method_address));

                l_delta:= l_pt_method_thunk^.m_delta;
              end
            else display('  not_thunk');
        end; // dump_thunk

      begin // dump_thunk_Click
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('i1 '+ f_integer_to_hex(Integer(g_i_compute)));
        display_vmt(Pointer(g_i_compute), 3+ 2);

        display_line;
        display('method_3 '+ f_integer_to_hex(Integer(@ ci_square.set_side)));
        dump_thunk(Pointer(g_i_compute), 3);

        display_line;
        display('itf_to_object ');
        display('itf     '+ f_integer_to_hex(Integer(g_i_compute)));
        display('+ delta '+ f_integer_to_hex(l_delta));
        display('=       '+ f_integer_to_hex(Integer(g_i_compute)+ l_delta));
        display('object  '+ f_integer_to_hex(Integer(g_ci_square)));
      end; // dump_thunk_Click

    procedure TForm1.display_object_Click(Sender: TObject);
      begin
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('object '+ f_integer_to_hex(Integer(g_ci_square)));
        display('iUnk   '+ f_integer_to_hex(Integer(g_i_unknown)));
        display('i2     '+ f_integer_to_hex(Integer(g_i_journal)));
        display('i1     '+ f_integer_to_hex(Integer(g_i_compute)));

        methods_Click(Nil);

        dump_object_Click(Nil);
        dump_vmt_Click(Nil);
        dump_imt_Click(Nil);
        dump_thunk_Click(Nil);
      end; // display_object_Click

    // -- separate calls

    procedure TForm1.imt_Click(Sender: TObject);

      type t_call_type= (e_function, e_procedure);

      procedure display_imt_entry(p_pointer: Pointer; p_method_index: Integer;
          p_call_type: t_call_type;
          p_title: String);
        var l_address: Integer;
            l_thunk_address: Integer;
            l_code_address: Integer;
        begin
          l_address:= Integer(p_pointer^)+ p_method_index* 4;
          l_thunk_address:= Integer(Pointer(l_address)^);

          // -- now find the code address in the thunk
          case p_call_type of
            e_function : l_code_address:= f_imt_function_jump_value(p_pointer, p_method_index);
            e_procedure : l_code_address:= f_imt_procedure_jump_value(p_pointer, p_method_index);
            else l_code_address:= 0;
          end; // p_call_type

          display(f_display_hex(Pointer(l_address), 4, 4, k_hex_address_hex)
              + '= '+ f_integer_to_hex(l_thunk_address)
              + ' ['+ f_integer_to_hex(l_code_address)+ ']'
              + '  '+ p_title);
        end; // display_imt_entry

      procedure display_iUnknown;
        begin
          display_line;
          display('iUn '+ f_integer_to_hex(Integer(g_i_unknown)));
          display_imt_entry(Pointer(g_i_unknown), 0, e_function, 'iUnknown.QueryInterface');
          display_imt_entry(Pointer(g_i_unknown), 1, e_function, 'iUnknown.Addref');
          display_imt_entry(Pointer(g_i_unknown), 2, e_function, 'iUnknown.Release');
        end; // display_iUnknown

      procedure display_i_journal;
        begin
          display_line;
          display('i2 '+ f_integer_to_hex(Integer(g_i_journal)));

          display_imt_entry(Pointer(g_i_journal), 0, e_function, 'i_journal.QueryInterface');
          display_imt_entry(Pointer(g_i_journal), 1, e_function, 'i_journal.Addref');
          display_imt_entry(Pointer(g_i_journal), 2, e_function, 'i_journal.Release');
          display_imt_entry(Pointer(g_i_journal), 3, e_procedure, 'i_journal.write_to_log');
        end; // display_i_journal

      procedure display_i_compute;
        begin
          display_line;
          display('i1 '+ f_integer_to_hex(Integer(g_i_compute)));
          display_imt_entry(Pointer(g_i_compute), 0, e_function, 'g_i_compute.QueryInterface');
          display_imt_entry(Pointer(g_i_compute), 1, e_function, 'g_i_compute.Addref');
          display_imt_entry(Pointer(g_i_compute), 2, e_function, 'g_i_compute.Release');
          display_imt_entry(Pointer(g_i_compute), 3, e_function, 'g_i_compute.set_side');
          display_imt_entry(Pointer(g_i_compute), 4, e_function, 'g_i_compute.compute_area');
        end; // display_i_compute

      begin // imt_Click
        if g_ci_square= Nil
          then create_Click(Nil);

        display_iUnknown;
        display_i_journal;
        display_i_compute;
      end; // imt_Click

    procedure TForm1.methods_Click(Sender: TObject);

      procedure display_code(p_pt_code: Pointer; p_title: String);
        begin
          display(f_display_hex(p_pt_code, 4, 4, k_hex_address_hex)+ '= '+ p_title);
        end; // display_code

      begin // methods_Click
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('methods');

        display_code(@ ci_square.create, 'ci_square.create');
        display_code(@ ci_square.set_side, 'ci_square.set_side');
        display_code(@ ci_square.compute_area, 'ci_square.compute_area');
        display_code(@ ci_square.write_to_journal, 'ci_square.write_to_journal');
        display_code(@ ci_square.write_and_display, 'ci_square.write_and_display');
        display_code(@ ci_square.analyze, 'ci_square.analyze');
        display_code(@ ci_square.analyze_virtual, 'ci_square.analyze_virtual');
        display_code(@ ci_square.destroy, 'ci_square.destroy');
      end; // methods_Click

    procedure TForm1.vmt_Click(Sender: TObject);

      procedure display_vmt_entry(p_pointer: Pointer; p_method_index: Integer; p_title: String);
        var l_address: Integer;
        begin
          l_address:= Integer(p_pointer)+ p_method_index* 4;
          display(f_display_hex(Pointer(l_address), 4, 4, k_hex_address_hex)+ '= '+ p_title);
        end; // display_vmt_entry

      begin // vmt_Click
        if g_ci_square= Nil
          then create_Click(Nil);
        display_line;
        display('ci_square vmt '+ f_integer_to_hex(Integer(ci_square)));
        display_vmt_entry(Pointer(ci_square), -10, 'ci_area_vmt[-$A0]  object_size');
        display('...');
        display_vmt_entry(Pointer(ci_square),  -1, 'ci_area_vmt[-$01]  vm 0 Destroy');
        display_vmt_entry(Pointer(ci_square),   0, 'ci_area_vmt[ $00]  vm 0 write_and_display');
        display_vmt_entry(Pointer(ci_square),   1, 'ci_area_vmt[ $01]  vm 0 analyze_virtual');
      end; // vmt_Click

    procedure TForm1.object_Click(Sender: TObject);

      procedure display_value(p_pointer: Pointer; p_integer_index: Integer; p_title: String);
        var l_address: Integer;
        begin
          l_address:= Integer(p_pointer)+ p_integer_index* 4;
          display(f_display_hex(Pointer(l_address), 4, 4, k_hex_address_hex)
             + ' '+ f_integer_to_hex(t_pt_integer(l_address)^)+ ' <= '+ p_title);
        end; // display_value

      begin // object_Click
        if g_ci_square= Nil
          then create_Click(Nil);

        display_line;
        display('object');
        display_value(g_ci_square, 0, 'pt_vmt');
        display_value(g_ci_square, 1, 'reference_count');
        display_value(g_ci_square, 2, 'pt_imt_iUnknown');
        display_value(g_ci_square, 3, 'm_side (= $1111)');
        display_value(g_ci_square, 4, 'm_area (= $2222)');
        display_value(g_ci_square, 5, 'pt_imt_journal');
        display_value(g_ci_square, 6, 'pt_imt_compute');
      end; // object_Click

    // -- call them all

    procedure TForm1.ci_detail_Click(Sender: TObject);
          // l_byte_count: Integer;
      begin
        if g_ci_square= Nil
          then create_Click(Nil);

        imt_Click(Nil);
        methods_Click(Nil);
        vmt_Click(Nil);
        object_Click(Nil);
      end; // ci_detail_Click

    procedure TForm1.call_Click(Sender: TObject);
      begin
        if g_ci_square= Nil
          then create_Click(Nil);
        g_ci_square.set_side($3333);
        g_i_compute.set_side($4444);

        g_ci_square.write_and_display;
        g_i_journal.write_and_display;
      end; // call_Click

end.




The layout of a VMT is
  At positive offsets, a VMT consists of a list of 32-bit method pointers
    one per user-defined virtual method in the class type
    in order of declaration.
    Each slot contains the address of the corresponding virtual methods entry point.
    This layout is compatible with a C++ v-table and with COM.
  At negative offsets, a VMT contains
    a number of fields that are internal to Object Pascals implementation.

Offset	Type	Description
76	Pointer	pointer to virtual method table (or nil)
72	Pointer	pointer to interface table (or nil)
68	Pointer	pointer to Automation information table (or nil)
64	Pointer	pointer to instance initialization table (or nil)
60	Pointer	pointer to type information table (or nil)
56	Pointer	pointer to field definition table (or nil)
52	Pointer	pointer to method definition table (or nil)
48	Pointer	pointer to dynamic method table (or nil)
44	Pointer	pointer to short string containing class name
40	Cardinal	instance size in bytes
36	Pointer	pointer to a pointer to ancestor class (or nil)
32	Pointer	pointer to entry point of SafecallException method (or nil)
28	Pointer	entry point of AfterConstruction method
24	Pointer	entry point of BeforeDestruction method
20	Pointer	entry point of Dispatch method
16	Pointer	entry point of DefaultHandler method
12	Pointer	entry point of NewInstance method
8	Pointer	entry point of FreeInstance method
4	Pointer	entry point of Destroy destructor
0	Pointer	entry point of first user-defined virtual method
4	Pointer	entry point of second user-defined virtual method
...	...	...
