// 012 u_vmt_imt
// 03 jun 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_vmt_imt;
  interface

    type t_vmt= array[0..0] of Integer;
         t_pt_vmt= ^t_vmt;

    const k_vmt_entries= 19;

          k_com_vmt_index= - 19;
          k_com_imt_index= - 18;
          k_object_size_index= - 10;
          k_destroy_index= -1;

    procedure display_vmt(p_pt_object: Pointer; p_virtual_method_count: Integer);
    function f_imt_function_jump_value(p_pt_imt: Pointer; p_method_index: Integer): Integer;
    function f_imt_procedure_jump_value(p_pt_imt: Pointer; p_method_index: Integer): Integer;

  implementation
    uses SysUtils, u_c_display, u_display_hex_2;

    procedure display_vmt(p_pt_object: Pointer; p_virtual_method_count: Integer);
      begin
        display(f_display_hex(Pointer(p_pt_object^), 4* p_virtual_method_count, 4, k_hex_address_hex));
      end; // display_vmt

    const k_add_byte_ptr_esp= $04244483;
          k_jump= $E9;
    type t_function_thunk= packed record
                                  m_add_byte_ptr_esp: longint;
                                  m_delta: byte;
                                  m_jump: Byte;
                                  m_jump_to_function_start: longint;
                                end;
         t_pt_function_thunk= ^t_function_thunk;

    function f_pt_function_thunk(p_pt_imt: Pointer; p_method_index: Integer): t_pt_function_thunk;
      begin
        (*$r-*)
        Result:= t_pt_function_thunk(t_pt_vmt(p_pt_imt^)[p_method_index]);
        (*$r+*)
      end; // f_pt_function_thunk

    function f_is_imt_function_thunk(p_pt_imt: Pointer; p_method_index: Integer): Boolean;
      begin
        with f_pt_function_thunk(p_pt_imt, p_method_index)^ do
          Result:= (m_add_byte_ptr_esp= k_add_byte_ptr_esp) and (m_jump= k_jump);
      end; // f_is_imt_function_thunk

    function f_imt_function_jump_value(p_pt_imt: Pointer; p_method_index: Integer): Integer;
      var l_pt_function_thunk: t_pt_function_thunk;
          l_function_address: Integer;
      begin
        if f_is_imt_function_thunk(p_pt_imt, p_method_index)
          then begin
              l_pt_function_thunk:= f_pt_function_thunk(p_pt_imt, p_method_index);
              // -- compute the absolute adress, starting from the start of "JMP XXX"
              Result:= $0A
                  + Longint(l_pt_function_thunk)
                  + l_pt_function_thunk^.m_jump_to_function_start;
            end
          else begin
              display('  not_thunk');
              Result:= 0;
            end;
      end; // f_imt_function_jump_value

    // -- procedure

    const k_add= $C083;
    type t_procedure_thunk= packed record
                                  m_add: Word;
                                  m_delta: Byte;
                                  m_jump: Byte;
                                  m_jump_to_procedure_start: longint;
                                end;
         t_pt_procedure_thunk= ^t_procedure_thunk;

    function f_pt_procedure_thunk(p_pt_imt: Pointer; p_method_index: Integer): t_pt_procedure_thunk;
      begin
        (*$r-*)
        Result:= t_pt_procedure_thunk(t_pt_vmt(p_pt_imt^)[p_method_index]);
        (*$r+*)
      end; // f_pt_procedure_thunk

    function f_is_imt_procedure_thunk(p_pt_imt: Pointer; p_method_index: Integer): Boolean;
      begin
        with f_pt_procedure_thunk(p_pt_imt, p_method_index)^ do
          Result:= (m_add= k_add) and (m_jump= k_jump);
      end; // f_is_imt_procedure_thunk

    function f_imt_procedure_jump_value(p_pt_imt: Pointer; p_method_index: Integer): Integer;
      var l_pt_procedure_thunk: t_pt_procedure_thunk;
          l_procedure_address: Integer;
      begin
        if f_is_imt_procedure_thunk(p_pt_imt, p_method_index)
          then begin
              l_pt_procedure_thunk:= f_pt_procedure_thunk(p_pt_imt, p_method_index);
              // -- compute the absolute adress, starting from the start of "JMP XXX"
              Result:= $08
                  + Longint(l_pt_procedure_thunk)
                  + l_pt_procedure_thunk^.m_jump_to_procedure_start;
            end
          else begin
              display('  not_thunk');
              Result:= 0;
            end;
      end; // f_imt_procedure_jump_value

  end.

